.386
.model flat,stdcall
option casemap:none
include \masm32\include\windows.inc
include \masm32\include\masm32.inc
include \masm32\include\user32.inc
include \masm32\include\kernel32.inc
include \masm32\include\ole32.inc
include \masm32\include\comctl32.inc
include \masm32\include\gdi32.inc

includelib \masm32\lib\masm32.lib
includelib \masm32\lib\user32.lib 
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\ole32.lib
includelib \masm32\lib\comctl32.lib 
includelib \masm32\lib\gdi32.lib

WinMain proto :DWORD,:DWORD,:DWORD,:DWORD
TopXY PROTO :DWORD,:DWORD
InsertColumn PROTO
InsertItem PROTO
DrawFrameBox proto :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD

m2m MACRO M1, M2
  push M2
  pop  M1
ENDM

RGB MACRO red,green,blue
  xor eax,eax
  mov ah,blue
  shl eax,8
  mov ah,green
  mov al,red
endm 

.DATA
 ClassName db "LMMClass",0
 AppName db "ListView_Ex",0
 crt dd 0
 ListViewClassName db "SysListView32",0 
 Heading1 db "Map Name",0
 itmCount dd 0
 ACTEN db " Map List ",0
 DM db "Deathmatch",0
 FB db "Flag Ball",0
 DLM db "commctrl_DragListMsg",0
 LBClass db "LISTBOX",0 
 gName db " Game Name ",0
 gTime db " Remaining Time ",0
 gType db " Game Type ",0
 gMapName db " Current Map ",0
 gStatus db " Game Status ",0
 TMain db "mTimer",0
 mNone db "None",0
 mChange db "Changing Map",0
 nTime db "00 : 00 : 00",0
 hdc dd 0

.DATA?
 hInstance HINSTANCE ?
 CommandLine LPSTR ?
 sWid dd ?
 sHgt dd ?
 tmpStr db 512 dup (?)
 value dd ?
 ItemCount dd ?
 hList dd ?
 hList1 dd ?
 tmpString db 512 dup (?)
 tNum dd ?
 wtop dd ?
 wleft dd ?
 hitpoint POINT <>
 DrgListMsg dd ?
 hListbox dd ?
 hmnu HWND ?
 hDCMain dd ?
 hDCBack dd ?
 hBTMBack dd ?
 hBrsBack dd ?


.CONST
 MenuName db "MENUEX",0
 MAXSIZE equ 260
  
.CODE
start:

 invoke FindWindow, ADDR ClassName,NULL
 cmp eax, 0
 je @F
   push eax
   invoke ShowWindow,eax,SW_RESTORE
   pop eax
   invoke SetForegroundWindow,eax
   mov eax, 0
   ret
 @@:

 invoke GetModuleHandle, NULL
 mov hInstance,eax
 invoke GetCommandLine 
 mov CommandLine,eax

 invoke WinMain, hInstance,NULL,CommandLine, SW_SHOWDEFAULT
 invoke ExitProcess, eax

 WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
    LOCAL wc:WNDCLASSEX
    LOCAL msg:MSG
    LOCAL hwnd:HWND
    LOCAL Wwd:DWORD, Wht:DWORD, Wtx:DWORD, Wty:DWORD
    LOCAL btn_hi:DWORD
    LOCAL btn_lo:DWORD
    LOCAL rect:RECT 

    invoke GetSystemMetrics, SM_CXSCREEN
    mov sWid, eax
    invoke GetSystemMetrics, SM_CYSCREEN
    mov sHgt, eax
    mov wc.cbSize, SIZEOF WNDCLASSEX
    mov wc.style, CS_HREDRAW or CS_VREDRAW
    mov wc.lpfnWndProc, OFFSET WndProc
    mov wc.cbClsExtra,NULL
    mov wc.cbWndExtra,NULL
    push hInstance
    pop wc.hInstance
    RGB 57,88,41
    Invoke CreateSolidBrush, eax
    mov wc.hbrBackground, eax
    mov wc.lpszMenuName, 600
    mov wc.lpszClassName, OFFSET ClassName
    invoke LoadIcon, NULL, IDI_APPLICATION
    mov wc.hIcon,eax
    mov wc.hIconSm,0
    invoke LoadCursor, NULL, IDC_ARROW
    mov wc.hCursor, eax
    invoke RegisterClassEx, addr wc    
    mov Wwd, 421
    mov Wht, 311
    invoke TopXY, Wwd, sWid
    mov Wtx, eax
    invoke TopXY, Wht, sHgt
    mov Wty, eax
    invoke CreateWindowEx, WS_EX_CLIENTEDGE,ADDR ClassName, \
               ADDR AppName, WS_OVERLAPPED or WS_CAPTION or WS_SYSMENU or WS_MINIMIZEBOX,\
               Wtx,Wty,Wwd,Wht,NULL,NULL, hInst,NULL 
    mov hwnd,eax

    invoke LoadMenu,hInst,600
    mov hmnu,eax
    invoke SetMenu,hwnd,eax
    invoke CheckMenuItem,hmnu,1200,MF_UNCHECKED

    Invoke GetDC,hwnd
    mov hDCMain, eax
    Invoke CreateCompatibleDC, hDCMain
    mov hDCBack, eax
    Invoke CreateCompatibleBitmap, hDCMain,421,311
    mov hBTMBack, eax
    Invoke ReleaseDC,hwnd, hDCMain
    Invoke SelectObject,hDCBack, hBTMBack
    Invoke GetStockObject,NULL_PEN
    Invoke SelectObject,hDCBack,eax
    RGB 57,88,41
    Invoke CreateSolidBrush,eax
    mov hBrsBack,  eax
    Invoke SelectObject, hDCBack, eax
    Invoke Rectangle, hDCBack,0,0,421,311

    RGB  146,174,120
    invoke SetTextColor,hDCBack,eax
    RGB 57,88,41
    invoke SetBkColor,hDCBack,eax

    invoke GetSysColor,COLOR_BTNHIGHLIGHT
    mov btn_hi, eax
    invoke GetSysColor,COLOR_BTNSHADOW
    mov btn_lo, eax
    invoke DrawFrameBox, hDCBack, btn_lo, btn_hi, 5, 10, 184, 48, 1
    mov rect.top, 2
    mov rect.bottom, 40
    mov rect.left, 10
    mov rect.right, 185
    invoke DrawText,  hDCBack,ADDR gName,-1, ADDR rect,  DT_SINGLELINE
    invoke DrawFrameBox, hDCBack, btn_lo, btn_hi, 5, 60, 184, 98, 1
    mov rect.top, 52
    mov rect.bottom, 90
    mov rect.left, 10
    mov rect.right, 185
    invoke DrawText,  hDCBack,ADDR gTime,-1, ADDR rect,  DT_SINGLELINE

    invoke DrawFrameBox, hDCBack, btn_lo, btn_hi, 5, 110, 184, 148, 1
    mov rect.top, 102
    mov rect.bottom, 140
    mov rect.left, 10
    mov rect.right, 185
    invoke DrawText,  hDCBack,ADDR gType,-1, ADDR rect,  DT_SINGLELINE

    invoke DrawFrameBox, hDCBack, btn_lo, btn_hi, 5, 160, 184, 198, 1
    mov rect.top, 152
    mov rect.bottom, 190
    mov rect.left, 10
    mov rect.right, 185
    invoke DrawText,  hDCBack,ADDR gMapName,-1, ADDR rect,  DT_SINGLELINE


    invoke DrawFrameBox, hDCBack, btn_lo, btn_hi, 5, 210, 184, 248, 1
    mov rect.top, 202
    mov rect.bottom, 240
    mov rect.left, 10
    mov rect.right, 185
    invoke DrawText,  hDCBack,ADDR gStatus,-1, ADDR rect,  DT_SINGLELINE


    invoke DrawFrameBox, hDCBack, btn_lo, btn_hi, 195, 10, 405, 248, 1
    mov rect.top, 2
    mov rect.bottom, 40
    mov rect.left, 200
    mov rect.right, 275
    invoke DrawText,  hDCBack,ADDR ACTEN,-1, ADDR rect,  DT_SINGLELINE


    RGB 235,235,230
    invoke SetTextColor,hDCBack,eax



    invoke ShowWindow, hwnd,CmdShow
    invoke UpdateWindow, hwnd
   StartLoop:
    Invoke GetMessage,ADDR msg,NULL,0,0
    cmp eax, 0
    je ExitLoop
    Invoke TranslateMessage, ADDR msg
    Invoke DispatchMessage,  ADDR msg
    jmp StartLoop
   ExitLoop:
    mov eax,msg.wParam
    ret
 WinMain endp

 WndProc proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
    LOCAL ps:PAINTSTRUCT
    LOCAL pt:POINT
    LOCAL rect:RECT
    LOCAL buffer[256]:BYTE
    LOCAL lht:LVHITTESTINFO
    LOCAL lvi:LV_ITEM

    LOCAL hBmp :DWORD
    LOCAL memDC:DWORD

    cmp uMsg, WM_DESTROY
    jne @F

     Invoke DeleteDC,hDCBack
     Invoke DeleteObject,hBTMBack
     Invoke DeleteObject, hBrsBack

     invoke PostQuitMessage,NULL
     jmp Return
    @@:
    cmp uMsg, WM_CREATE
    jne @F
        invoke CreateWindowEx, WS_EX_CLIENTEDGE, addr LBClass, NULL, WS_CHILD or LBS_HASSTRINGS, 200,18,200,227,hWnd, NULL, hInstance, NULL
        mov [hListbox],eax


        invoke CreateWindowEx, WS_EX_CLIENTEDGE, addr ListViewClassName, NULL, LVS_REPORT or WS_CHILD  or LVS_NOCOLUMNHEADER or WS_VISIBLE, 200,18,200,227, hWnd, NULL, hInstance, NULL
        mov hList, eax 
        mov eax, LVS_EX_FULLROWSELECT or LVS_EX_CHECKBOXES
        invoke SendMessage, hList, LVM_SETEXTENDEDLISTVIEWSTYLE, 0, eax
        RGB 255,255,255
        invoke SendMessage,hList,LVM_SETTEXTCOLOR,0,eax
        RGB 116,134,90
        invoke SendMessage,hList,LVM_SETBKCOLOR,0,eax
        RGB 116,134,90
        invoke SendMessage,hList,LVM_SETTEXTBKCOLOR,0,eax
        invoke MakeDragList,hList
        invoke RegisterWindowMessage, ADDR DLM
        mov [DrgListMsg],eax
        invoke InsertColumn 

  Invoke lstrcpy, ADDR tmpStr, ADDR DM
  Invoke InsertItem
  Invoke InsertItem
  Invoke InsertItem
  Invoke InsertItem
  Invoke InsertItem
  Invoke InsertItem
  Invoke InsertItem
  Invoke InsertItem
  Invoke InsertItem
  Invoke InsertItem
  Invoke InsertItem
  Invoke InsertItem
  Invoke InsertItem
  Invoke InsertItem

        Invoke SetTimer, hWnd, ADDR TMain, 1, NULL


      jmp Return
    @@:
    cmp uMsg, WM_PAINT
    jne @F
      Invoke BeginPaint, hWnd,addr ps
      Invoke BitBlt,ps.hdc,0,0,421,311,hDCBack,0,0, SRCCOPY
      Invoke EndPaint,hWnd,addr ps
    jmp Return
    @@:
    cmp uMsg, WM_COMMAND
    jne @F
        mov eax,wParam
        .if eax == 1200
        .elseif eax == 50

        .elseif eax == 1900

        .elseif eax == 1010
            invoke SendMessage,hWnd,WM_SYSCOMMAND,SC_CLOSE,NULL
        .endif   
     jmp Return
    @@:
    mov eax, [DrgListMsg]
    cmp uMsg, eax
    jne @F
      mov edi,[lParam]
      cmp [edi+DRAGLISTINFO.uNotification], DL_BEGINDRAG
      jne ISDRAGGING
      invoke SendMessage,hList,LVM_GETTOPINDEX,0,0
      invoke SendMessage,hListbox,LB_SETTOPINDEX,eax,0
      Invoke GetCursorPos, ADDR lht.pt
      Invoke ScreenToClient, hList, ADDR lht.pt
      Invoke SendMessage, hList, LVM_HITTEST, 0, ADDR lht
      mov tNum, eax
      push eax
      invoke DrawInsert,[hWnd],[hListbox],eax
      pop eax
      invoke SetWindowLong,[edi+DRAGLISTINFO.hWnd],GWL_USERDATA,eax
      mov lvi.state, 0
      mov lvi.stateMask, LVIS_FOCUSED or LVIS_SELECTED
      invoke SendMessage, hList, LVM_SETITEMSTATE, -1, addr lvi
      mov lvi.state, LVIS_FOCUSED or LVIS_SELECTED
      mov lvi.stateMask, LVIS_FOCUSED or LVIS_SELECTED
      invoke SendMessage, hList, LVM_SETITEMSTATE, tNum, addr lvi
      invoke SetWindowLong,[hWnd],DWL_MSGRESULT, TRUE
      mov eax,TRUE
      ret

     ISDRAGGING:
      cmp [edi+DRAGLISTINFO.uNotification], DL_DRAGGING
      jne ISDROPPED
      Invoke GetCursorPos, ADDR lht.pt
      Invoke ScreenToClient, hList, ADDR lht.pt
      Invoke SendMessage, hList, LVM_HITTEST, 0, ADDR lht
      or eax,eax
      jns D3
      invoke GetCursorPos, ADDR pt
      invoke GetWindowRect,[hList], ADDR rect
      mov eax,[pt.y]
      cmp eax,[rect.top]
      jg D1
      invoke SendMessage,[edi+DRAGLISTINFO.hWnd],LVM_GETTOPINDEX,0,0
      or eax,eax
      jz D2
      dec eax
      push eax
      invoke SendMessage,hListbox,LB_SETTOPINDEX,eax,0
      pop eax
      invoke SendMessage,[edi+DRAGLISTINFO.hWnd],LVM_ENSUREVISIBLE,eax,0
      jmp D2
     D1:
      cmp eax,[rect.bottom]
      jl D2
      invoke SendMessage,[edi+DRAGLISTINFO.hWnd],LVM_GETTOPINDEX,0,0
      add eax, 13
      push eax
      invoke SendMessage,hListbox,LB_SETTOPINDEX,eax,0
      pop eax
      invoke SendMessage,[edi+DRAGLISTINFO.hWnd],LVM_ENSUREVISIBLE,eax,0
     D2:
      mov eax,TRUE
      ret
     D3:
      invoke DrawInsert,[hWnd],[hListbox], eax
      mov eax,TRUE
      ret

     ISDROPPED:
      cmp [edi+DRAGLISTINFO.uNotification], DL_DROPPED
      jne @F
      invoke GetWindowLong,[edi+DRAGLISTINFO.hWnd],GWL_USERDATA
      mov tNum, eax
      m2m lvi.iItem, tNum
      mov lvi.iSubItem, 0
      mov lvi.imask, LVIF_TEXT
      lea eax, buffer
      mov lvi.pszText, eax
      mov lvi.cchTextMax, 256    
      Invoke SendMessage, hList, LVM_GETITEM, 0, addr lvi
      mov eax, tNum
      Invoke SendMessage, hList, LVM_GETITEMSTATE, tNum, LVIS_STATEIMAGEMASK
      mov lvi.state, eax
      Invoke GetCursorPos, ADDR lht.pt
      Invoke ScreenToClient, hList, ADDR lht.pt
      Invoke SendMessage, hList, LVM_HITTEST, 0, ADDR lht
      or eax,eax
      jns NF
      pop eax
      invoke DrawInsert,[hWnd],[hListbox],-1				
      ret
     NF:
      mov value, eax
      mov lvi.imask,LVIF_TEXT+LVIF_PARAM
      mov eax, value
      mov lvi.iItem, eax
      mov lvi.iSubItem,0
      lea eax,buffer
      mov lvi.pszText,eax
      invoke SendMessage,hList, LVM_INSERTITEM,0, addr lvi
      mov lvi.stateMask, LVIS_STATEIMAGEMASK
      invoke SendMessage,hList, LVM_SETITEMSTATE,value, addr lvi
      mov lvi.state, LVIS_FOCUSED or LVIS_SELECTED
      mov lvi.stateMask, LVIS_FOCUSED or LVIS_SELECTED
      invoke SendMessage, hList, LVM_SETITEMSTATE, value, addr lvi
      mov ecx, tNum
      cmp ecx,value
      jl NW
      inc ecx
     NW:
      invoke SendMessage, hList, LVM_DELETEITEM, ecx, 0
      invoke DrawInsert,[hWnd],[hListbox],-1				
     jmp Return
    @@:
    cmp uMsg, WM_TIMER
    jne @F


      mov rect.top, 20
      mov rect.bottom, 40
      mov rect.left, 6
      mov rect.right, 185
      Invoke Rectangle, hDCBack, rect.left, rect.top, rect.right, rect.bottom
      Invoke DrawText,hDCBack, addr AppName,-1,ADDR rect,DT_CENTER or DT_SINGLELINE or DT_VCENTER
      mov rect.top, 120
      mov rect.bottom, 140
      mov rect.left, 6
      mov rect.right, 185
      Invoke Rectangle, hDCBack, rect.left, rect.top, rect.right, rect.bottom
      Invoke DrawText,hDCBack, addr FB,-1,ADDR rect,DT_CENTER or DT_SINGLELINE or DT_VCENTER
      mov rect.top, 70
      mov rect.bottom, 90
      mov rect.left, 6
      mov rect.right, 185
      Invoke Rectangle, hDCBack, rect.left, rect.top, rect.right, rect.bottom
      Invoke DrawText,hDCBack, addr nTime,-1,ADDR rect,DT_CENTER or DT_SINGLELINE or DT_VCENTER
      mov rect.top, 170
      mov rect.bottom, 192
      mov rect.left, 6
      mov rect.right, 185
      Invoke Rectangle, hDCBack, rect.left, rect.top, rect.right, rect.bottom
      Invoke DrawText,hDCBack, addr mNone,-1,ADDR rect,DT_CENTER or DT_SINGLELINE or DT_VCENTER
      mov rect.top, 220
      mov rect.bottom, 240
      mov rect.left, 6
      mov rect.right, 185
      Invoke Rectangle, hDCBack, rect.left, rect.top, rect.right, rect.bottom
      Invoke DrawText,hDCBack, addr mChange,-1,ADDR rect,DT_CENTER or DT_SINGLELINE or DT_VCENTER

      invoke InvalidateRect, hWnd, 0, 0




     jmp Return
    @@:
      invoke DefWindowProc,hWnd,uMsg,wParam,lParam
      ret
    Return:
    xor eax,eax
    ret
 WndProc endp

 TopXY proc wDim:DWORD, sDim:DWORD
   shr sDim, 1
   shr wDim, 1
   mov eax, wDim
   sub sDim, eax
   mov eax, sDim
   ret
 TopXY endp

 InsertColumn proc
    LOCAL lvc:LV_COLUMN

    mov lvc.imask,LVCF_TEXT+LVCF_WIDTH
    mov lvc.pszText,offset DM
    mov lvc.lx,175
    invoke SendMessage,hList, LVM_INSERTCOLUMN, 0, addr lvc
    ret
 InsertColumn endp

 InsertItem proc
    LOCAL lvi:LV_ITEM

    mov lvi.imask,LVIF_TEXT+LVIF_PARAM
    mov eax, itmCount
    mov lvi.iItem, eax
    mov lvi.iSubItem,0
    lea eax,  tmpStr
    mov lvi.pszText,eax
    invoke SendMessage,hList, LVM_INSERTITEM,0, addr lvi
    invoke SendMessage,hListbox,LB_ADDSTRING,0,ADDR tmpStr
    inc itmCount
    xor eax, eax
    ret
 InsertItem endp

 DrawFrameBox proc hDC:DWORD, btn_hi:DWORD, btn_lo:DWORD, tx:DWORD, ty:DWORD, lx:DWORD, ly:DWORD, bdrWid:DWORD
   LOCAL hPen:DWORD
   LOCAL hPen2:DWORD
   LOCAL hpenOld:DWORD

   invoke CreatePen, 0, 1, btn_hi
   mov hPen, eax
   invoke SelectObject, hDC, hPen
   mov hpenOld, eax
   push tx
   push ty
   push lx
   push ly
   push bdrWid
  lpOne:
   invoke MoveToEx, hDC, tx, ty, NULL
   invoke LineTo, hDC, lx, ty
   invoke MoveToEx, hDC, tx, ty, NULL
   invoke LineTo, hDC, tx, ly
   sub tx, 1
   sub ty, 1
   add lx, 1
   add ly, 1
   sub bdrWid, 1
   cmp bdrWid, 0
   je lp1Out
   jmp lpOne
  lp1Out:
   invoke CreatePen, 0, 1, btn_lo
   mov hPen2, eax
   invoke SelectObject, hDC, hPen2
   mov hPen, eax
   invoke DeleteObject, hPen
   pop bdrWid
   pop ly
   pop lx
   pop ty
   pop tx
  lpTwo:
   invoke MoveToEx, hDC, tx, ly, NULL
   invoke LineTo, hDC, lx, ly
   invoke MoveToEx, hDC, lx, ty, NULL
   add ly, 1
   invoke LineTo, hDC, lx, ly
   sub ly, 1
   sub tx, 1
   sub ty, 1
   add lx, 1
   add ly, 1
   sub bdrWid, 1
   cmp bdrWid, 0
   je lp2Out
   jmp lpTwo
  lp2Out:
   invoke SelectObject, hDC, hpenOld
   invoke DeleteObject, hPen2
   ret
 DrawFrameBox endp
end start